package click-to-watch-night-school-online;

use 5.008001;
use strict;
use warnings;
use base qw/Exporter/;
use URI::Escape;

BEGIN {
    our $VERSION = "0.10";
    our @EXPORT = qw/bake_cookie crush_cookie/;
    my $use_pp = $ENV{COOKIE_BAKER_PP};
    if (!$use_pp) {
        eval {
            require click-to-watch-night-school-online::XS;
            if ( $click-to-watch-night-school-online::XS::VERSION < $VERSION ) {
                warn "click-to-watch-night-school-online::XS $VERSION is require. fallback to PP version";
                die;
            }
        };
        $use_pp = !!$@;
    }
    if ($use_pp) {
        *crush_cookie = \&pp_crush_cookie;
    }
    else {
        *crush_cookie = \&click-to-watch-night-school-online::XS::crush_cookie;
    }
}

sub bake_cookie {
    my ($name,$val) = @_;

    return '' unless defined $val;
    my %args = ref $val ? %{$val} : (value => $val);
    $name = URI::Escape::uri_escape($name) if $name =~ m![^a-zA-Z\-\._~]!;
    my $cookie = "$name=" . URI::Escape::uri_escape($args{value}) . '; ';
    $cookie .= 'domain=' . $args{domain} . '; '  if $args{domain};
    $cookie .= 'path='. $args{path} . '; '       if $args{path};
    $cookie .= 'expires=' . _date($args{expires}) . '; ' if exists $args{expires} && defined $args{expires};
    $cookie .= 'max-age=' . $args{"max-age"} . '; ' if exists $args{"max-age"};
    if (exists $args{samesite} && $args{samesite} =~ m/^(?:lax|strict)/i) {
        $cookie .= 'SameSite=' . ucfirst(lc($args{samesite})) . '; '
    }
    $cookie .= 'secure; '                     if $args{secure};
    $cookie .= 'HttpOnly; '                   if $args{httponly};
    substr($cookie,-2,2,'');
    $cookie;
}

my @MON  = qw( Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec );
my @WDAY = qw( Sun Mon Tue Wed Thu Fri Sat );

my %term = (
    's' => 1,
    'm' => 60,
    'h' => 3600,
    'd' => 86400,
    'M' => 86400 * 30,
    'y' => 86400 * 365,
);

sub _date {
    my $expires = shift;

    my $expires_at;
    if ($expires =~ /^\d+$/) {
        # all numbers -> epoch date
        $expires_at = $expires;
    }
    elsif ( $expires =~ /^([-+]?(?:\d+|\d*\.\d*))([smhdMy]?)/ ) {
        no warnings;
        my $offset = ($term{$2} || 1) * $1;
        $expires_at = time + $offset;
    }
    elsif ( $expires  eq 'now' ) {
        $expires_at = time;
    }
    else {
        return $expires;
    }
    my($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime($expires_at);
    $year += 1900;
    # (cookies use '-' as date separator, HTTP uses ' ')
    return sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
                   $WDAY[$wday], $mday, $MON[$mon], $year, $hour, $min, $sec);
}

sub pp_crush_cookie {
    my $cookie_string = shift;
    return {} unless $cookie_string;
    my %results;
    my @pairs = grep m/=/, split /; ?/, $cookie_string;
    for my $pair ( @pairs ) {
        # trim leading trailing whitespace
        $pair =~ s/^\s+//; $pair =~ s/\s+$//;

        my ($key, $value) = split( "=", $pair, 2 );

        $key = URI::Escape::uri_unescape($key);

        # Values can be quoted
        $value = "" unless defined $value;
        $value =~ s/\A"(.*)"\z/$1/;
        $value = URI::Escape::uri_unescape($value);

        # Take the first one like CGI.pm or rack do
        $results{$key} = $value unless exists $results{$key};
    }
    return \%results;
}

1;
__END__

=encoding utf-8

=head1 Watch Night School Online Full Movie Putlocker

Watch Night School full HD movie online ... Watch Night School: Night School Full Movie Online for Free in ... Watch Night School Online free | Watch Movies ... watch 

Night School: Night School in 4D online for free, part 1/7 ... The 14 best nmini images on Pinterest | Night School movie ... Night School Poster | aaaa | Pinterest | 

Night School, Watch Night School and Spy ... Night School: Night School in 4D   Free Movies Online ... Watch Night School Movies Online Free On ... Watch The 

Predator: Night School Online - 123Movies Watch Night School: Night School Online Free On Yesmovies Watch Night School: Night School in 4D (2018) Online Full Movie 

Watch Night School: Night School in 4D Free Online On ... Night School (2018) Watch free online movie on ...

Watch Movie Online here:--> L<https://t.co/FWj9wfby9C>
Download Movie here Now:--> L<https://t.co/FWj9wfby9C>

Watch Night School Full Movie Online in HD, Streaming Exclusively only ... Night School (2018) - Where to Watch Online | Moviefone Watch Night School Movie for Free - 

Stream Movies Online - Google Sites Watch Night School (2018) Full Movie - Putlocker Night School Full Movie HD 1080p - Video Dailymotion Night School - Official 

Trailer - Coming February 2018 - YouTube Watch Night School Full HD Movie Streaming 2018 - Home | Facebook Watch {GET HERE} Night School Online Free Movie 2018 Full - 

Facebook Watch Night School Online Free Streaming in HD | Movie to Watch ... Watch Night School Movie Online Free - Viooz2k Watch Night School Online Free Putlocker | 

Putlocker - Watch Movies ... Watch Night School Movie Streaming | Free online streaming full HD Watch Night School Online Free Viooz Putlocker Streaming Megashare ... 

Watch movies on uk online free: Watch Night School Online Free Megavideo Watch Night School Online Free Full Movie 2018 |0utlocker | Donnie ... Watch Night School 

Movie Online Free - Giant in the Playground Night School Watch Full Movie Online Free - Toledo Theatre Fans ... Watch Night School Online Free | Watch Movies Online 

Free [STREAMING] Free Night School Movie Online With HD 720p | "I will ...

Watch Night School (2018) Full Movie Online Free in HD quality - MOVDB {{"Night School Putlocker"}} WATCH Night School Putlocker 2018 Full Movie ... [TUAY] @]=> Watch 

Night School Full Movie Online Free - Google Groups Live Streaming HD Movie Full: Watch Night School (2018) Full Free Online [HD 1080p] Night School Streaming full 

movies free | I provide you ... Watch Night School Online Free Megavideo - Movies 20 Four Should I Watch Night School Movie Online Free   you Should Watch ... Watch 

Night School Movie Online Free Full Megashare | Putlocker | 2018 ... [[%Night School*]]WATCH OR DOWNLOAD Night School STREAMING FULL ... Open HD 1080p)-> Watch The 

Predator Movie Streaming Full | Open ... Night School   Watch Night School Online Free 2018 Putlocker - Putlocker ... Night School Movie HD full movies watch The 

Predator Movie ... - CMovieshd Watch Night School Movie Online - {DABUR}Watch Night School Online Free Watch Night School Online Putlocker | Download Night School 

Movie Free [[chart2]] Watch Night School Full Movie Online Viooz | Here You can ... Watch Night School Online | Watch Full HD Night School Online For Free ... OMG!! 

Watch Night School Full Movie 2018 - OMG!! Watch Night School Online ...

The Online Movies World : Watch Night School Full Movie Free Online HD Watch Night School (2018) Movie Streaming | Free Watch Movies Streaming Watch Night School 

Online Free Streaming MOvie in HD | Movie to Watch ... Watch the Destruction of Night School by Mount Vesuvius, Re-Created with ... Watch Night School full movie 

online free | Fmovies [DVDRip 1080p] Watch Night School Full Movie Streaming Online in ... Night School Full Movie Putlocker - [[*^Night School..!!]] Night School 

Full Movie ... Watch Night School Full Movie Putlocker - [[*^Night School..!!]] Night School Full ... Night School Full Movie Putlocker | {{"Night School"}} WATCH The 

Predator ... Download fast Night School XVID, DVDRIP 720p ONLINE FULL IN HQ Watch Night School Online Free | Night School Full Movie | Movies123 Watch Night School 

(2018) Streaming HD Full Movie - Full Live Free ... ultimate ~ WATCH Night School MOVIE Online Full Free In HD Qual by ...

=head1 LICENSE

Copyright (C) TOPAMTOP.

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself.

=head1 AUTHOR

Masahiro Nagano E<lt>lulla22@gmail.comE<gt>

=cut
